/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * Andreas Krennmair <ak@synflood.at> wrote this file.  As long as you retain
 * this notice you can do whatever you want with this stuff. If we meet some day, 
 * and you think this stuff is worth it, you can buy me a beer in return.
 *   -- Andreas Krennmair <ak@synflood.at>
 * ----------------------------------------------------------------------------
 */
#include "poperattess.h"

#include <unistd.h>
#include <pwd.h>
#include <shadow.h>
#include <sys/types.h>
#include <limits.h>

#include <buffer.h>
#include <str.h>
#include <stralloc.h>

static int goto_jail(const char *dir, uid_t uid, gid_t gid)
{
	if (chdir(dir) != 0 || chroot(dir) != 0 || chdir("/") != 0 || setgid(gid) != 0 || setuid(uid) != 0)
		return 0;
	return 1;
}

int auth_user(const char *user, const char *pass)
{
	struct passwd *spu = NULL;
	struct spwd *s = NULL;
	char *sys_pw = NULL;
	int retval = 0;
	stralloc maildir;

	spu = getpwnam(user);
	if (!spu) {
		return 0;
	}

	stralloc_init(&maildir);
	stralloc_cats(&maildir, spu->pw_dir);
	stralloc_cats(&maildir, "/");
	stralloc_cats(&maildir, "Maildir");
	stralloc_0(&maildir);

	if (str_equal(spu->pw_passwd, "x")) {
		s = getspnam(user);
		if (s)
			sys_pw = s->sp_pwdp;
	} else {
		sys_pw = spu->pw_passwd;
	}

	if (sys_pw != NULL && str_equal(crypt(pass, sys_pw), sys_pw)) {
		retval = goto_jail(maildir.s, spu->pw_uid, spu->pw_gid);
	}

	stralloc_free(&maildir);
	return retval;
}
